;
;
;  Program to test port I/O on a PC/AT clone. It will take a
;  hex-ASCII port number on the command line. It defaults to
;  port 0, a DMA controller address register R/W port.
;
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
.386
MSDOS	equ	21h
EXIT	equ	4c00h
STDOUT	equ	0200h
INSTAT	equ	0b00h
CR	equ	0dh
LF	equ	0ah
PORT	equ	00h
DUMMY	equ	1000h
ARGS	equ	80h
ISTR	equ	82h
MAGIC	equ	0aa61h
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

pseg segment para use16 public 'Code'
assume cs:pseg, ds:pseg, es:pseg, ss:pseg
org	100h
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
;
;	Assume nothing. Set up the environment we want.
;
start	proc	near
	cld
	mov	ax,cs		; Wherever we are
	mov	ds,ax		; Set segments
	mov	ds,ax
	mov	ss,ax
	mov	sp, offset main	; Set stack
	call	main
	mov	ax, EXIT
	int	MSDOS
start	endp
ascii	db	'0123456789abcdef'
psignon	db	CR,LF,'Port tester for port 0x'
prt	db	'0000',CR,LF
quit	db	'[Enter] or ^C to quit',CR,LF,0
msignon	db	CR,LF,'Memory tester for segment 0x'
smem	db	'0000',CR,LF,0
prp3	db	'Test failed at offset 0x'
off	db	'0000',CR,LF
prp1	db	'Value was 0x'
was	db	'0000'
prp2	db	', should have been 0x'
sab	db	'0000'
	db	CR,LF,0
cmd_prt	db	"PORT="
cmd_prt_len	equ ($ - cmd_prt)
cmd_mem	db	"MEM="
cmd_mem_len	equ ($ - cmd_mem)
usage	db	'Usage:',CR,LF
	db	'PTEST [PORT=hex (port)] [MEM=hex (segment)]',CR,LF,0
mem	dw	0
rnd	dw	0
old_rnd	dw	0
prtnum	dw	PORT
	db	10h dup('STACK   ')
even
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
main	proc	near
	call	getcmd			; Get command line
	cmp	word ptr[mem], 0	; See if for memory
	jz	isport			; It's for port I/O
	mov	di,offset smem
	mov	ax,word ptr [mem]	; Get memory segment
	call	hexw			; Convert
	mov	si,offset msignon	; Point to signon message
	call	print			; Print it
	mov	si,offset quit		; Point to quit prompt
	call	print			; Print it
	jmp	mtester			; Go to memory test 

isport:	mov	di,offset prt		; Point to text
	mov	ax,word ptr [prtnum]	; Port to use
	call	hexw			; Convert to hex-ASCII
	mov	si,offset psignon	; Point to signon message
	call	print			; Print signon message
	jmp	ptester			; Exercise the tester
main	endp
;
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
;
;	The main port test routine
;
ptester	proc	near
	xor	dx,dx
again:	mov	ax,dx		; Get a number
	push	dx		; Save value
	call	doit		; Test the port
	pop	dx		; Restore value
	jz	wasok		; It was okay
	mov	di,offset was	; Bad, convert to hex-ASCII
	call	hexw		; Convert
	mov	ax,dx		; What it should have been
	mov	di,offset sab	; Point to string
	call	hexw		; Convert
	mov	si,offset prp1	; Point to string
	call	print		; Print it
wasok:	inc	dx
	jnz	again
	mov	ax,INSTAT	; Console status
	int	MSDOS
	or	al,al		; Check status
	jz	ptester		; Nothing yet
	ret
ptester	endp
;
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
;
;  This is a simple random number generator. It returns the value
;  in AX.
;
rand	proc	near
	mov	ax, word ptr [rnd]
	ror	ax,1
	ror	ax,1
	ror	ax,1
	add	ax, MAGIC
	mov	word ptr [rnd], ax
	ret
rand	endp
;
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
;
;  This xors the contents of memory words with the value in AX
;
xormem	proc	near
	push	ds
	mov	ds, word ptr [mem]
	xor	bx,bx		; Offset zero
loxpr:	xor	word ptr [bx], ax
	add	bx, 2
	jnc	loxpr
	pop	ds
	ret
xormem	endp
;
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
;
;  This checks the memory contents against a random number
;
chkmem	proc	near
	push	ds
	mov	dx,ds			; Get current segment
	xor	bx,bx			; Offset zero
chkm:	mov	ds,dx			; Program's DS
	call	rand			; Get a random number
	mov	ds, word ptr [mem]	; Segment being tested
	mov	cx, word ptr [bx]	; Get memory word
	cmp	cx, ax			; Check word
	jz	chkm1			; It is okay
	pop	ds
;
;	Failing word is in CX. What it should have been is in AX.
;	The offset into the segment is in BX. 
;
	push	bx
	push	cx
	mov	di, offset sab
	call	hexw
	pop	ax
	mov	di, offset was
	call	hexw
	pop	ax
	mov	di, offset off
	call	hexw
	mov	si, offset prp3
	call	print
	ret
;
chkm1:	add	bx, 2			; Ready next
	jnc	chkm			; Fill all words
	pop	ds
	ret
chkmem	endp
;
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
;
;   This fills memory with a random word.
;
fillran	proc	near
	push	ds
	mov	dx,ds			; Get current segment
	xor	bx,bx			; Offset zero
fill:	mov	ds,dx			; Program's DS
	call	rand			; Get a random number
	mov	ds, word ptr [mem]	; Segment being tested
	mov	word ptr [bx], ax	; Write word
	add	bx, 2			; Ready next
	jnc	fill			; Fill all words
	pop	ds
	ret
fillran	endp
;
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
;
;  This is that memory test routine which tests a 64k block of
;  memory 'forever'.
;
mtester	proc	near
	mov	word ptr [rnd],0ffffh
mcont:	mov	ax, word ptr [rnd]
	mov	word ptr [old_rnd], ax
	call	fillran
	mov	ax,0aa55h
	call	xormem
	mov	ax,055aah
	call	xormem
	mov	ax,0ffffh
	call	xormem
	mov	ax,0000h
	call	xormem
	mov	ax,5555h
	call	xormem
	mov	ax,0aaaah
	call	xormem
;
	mov	ax,0aa55h
	call	xormem
	mov	ax,055aah
	call	xormem
	mov	ax,0ffffh
	call	xormem
	mov	ax,0000h
	call	xormem
	mov	ax,5555h
	call	xormem
	mov	ax,0aaaah
	call	xormem
	mov	ax,word ptr [old_rnd]
	mov	word ptr [rnd],ax
	call	chkmem
;
	mov	ax,INSTAT	; Console status
	int	MSDOS
	or	al,al		; Check status
	jz	mcont		; Nothing yet
	ret
mtester	endp
;
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
;
;	This maps the string pointed to by DS:BX to upper
;	case.
;
upper	proc	near
	mov	al, byte ptr [bx]	; Get byte
	or	al,al			; Check for end
	jz	eos			; End of string
	cmp	al,'a'			; Check lower limit
	jb	next			; Not lower case
	cmp	al,'z'+1		; Check upper limit
	jnb	next			; Not lower case
	and	al, 95			; Reset lower-case bits
	mov	byte ptr [bx],al	; Replace
next:	inc	bx
	jmp	short upper
eos:	ret
upper	endp
;
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
;
;   This returns the string length in AX. Registers ES:DI point
;   to the string upon entry.
;
strlen	proc	near
	push	cx		; Save substring length
	xor	al,al		; Find nul
	or	cx,0ffffh	; Max possible
	repnz	scasb		; find the nul
	neg	cx		; Convert
	dec	cx		; String length
	mov	ax,cx		; Save count
	pop	cx		; Restore substring length
	ret
strlen	endp
;
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
;
;   This gets a substring in ES:DI, a string in DS:SI, and a substring
;   length in CX. It tries to locate the substring within the string
;   and, if found, returns non-zero and the string location after the
;   element found, is DS:SI.
;
token	proc	near
	push	di
	mov	di,si
	call	strlen
	pop	di
	mov	dx,ax
;
;	At this point the string length is in DX
;
toke0:	push	cx
	push	si
	push	di
	repz	cmpsb
	mov	bx,si		; In case we found it
	pop	di
	pop	si
	pop	cx
	jz	found
	inc	si
	dec	dx
	jz	notoke
	jmp	short toke0	
found:	mov	si,bx		; Return location after token
	or	cx,0ffffh	; Set flags
notoke:	ret
token	endp
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
;
;   Convert whatever is pointed to by DS:SI to binary and return
;   it is AX.
;
hex2bin	proc	near
	xor	dx,dx		; Use as an accumulator
getmor:	lodsb			; Get byte
	sub	al, '0'		; Remove ASCII bias
	jc	getdun		; All done
	cmp	al,10		; check limits
	jc	cnvrt		; Was converted (0->9)
	and	al,95		; Remove lower case bits (a->A)
	sub	al,7		; Hex bias (A - 9)
	jc	getdun		; All done
cnvrt:	shl	dx,4		; Shift
	or	dl,al		; Put into place
	jmp	short getmor
getdun:	mov	ax,dx
	ret
hex2bin	endp
;
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
;
;	This gets any hex-ASCII from the command line
;	and writes its value to 'prtnum'.
;
getcmd	proc	near
	mov	si,ARGS			; Point to command-line
	xor	bx,bx			; Clear pointer
	lodsb				; Get byte count
	mov	bl,al			; Low byte of pointer
	mov	byte ptr [bx+si], 0	; Make ASCIIZ
	mov	bx,ISTR			; Point to string
        cmp     byte ptr [bx], '?'	; See if we want help
	jnz	nohelp			; Nope
	mov	si,offset usage		; Point to help
	call	print			; Print it
	mov	ax,EXIT
	int	MSDOS
;
nohelp:	call	upper			; Map to upper case
	mov	si,ISTR			; Beginning of input string
	mov	di,offset cmd_prt	; Point to token
	mov	cx,cmd_prt_len		; Command length
	call	token			; See if it's there
	jz	nport			; No port value
	call	hex2bin			; Convert to binary
	mov	word ptr [prtnum], ax	; Save port number
	jmp	short nmem		; Quit
nport:	mov	si,ISTR			; Pointer to command line
	mov	di,offset cmd_mem	; Point to token
	mov	cx,cmd_mem_len		; Command length
	call	token			; See if it is there
	jz	nmem			; Nope
	call	hex2bin			; Convert to binary
	mov	word ptr [mem], ax	; Save memory location
nmem:	ret
getcmd	endp
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
;
;	This takes the value in AX and writes it to a port.
;	It then exercises the bus and then reads from the port.
;	If the value is the same as written, it returns with the
;	zero flag set. If it is different, it returns nonzero
;	with the value read in register AX
;
doit	proc	near
	mov	bx, word ptr [prtnum]
	mov	cx,ax		; Save value
	mov	dx,bx		; Set port
	out	dx,ax		; Write to port
	or	ax, 0ffffh	; Set all bits
	mov	dx, DUMMY	; Some other port
	out	dx,ax		; Put data on bus
	mov	dx,bx		; Get saved port number
	in	ax,dx		; Read the port
	cmp	ax,cx		; Check results
	ret
doit	endp
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
;
;  This takes a null-terminated string, pointed to by DS:SI
;  and writes it to standard output. 
;
print	proc	near
	push	dx
getb:	lodsb			; Get byte
	or	al,al		; Check for nul
	jz	pout		; End of string
	push	si		; DOS destroys this
	mov	dl,al		; Character in register DL
	mov	ax,STDOUT	; Console output
	int	MSDOS
	pop	si		; Restore
	jmp	short getb	; Continue
pout:	pop	dx
	ret
print	endp
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
;
;	This converts the input in AX to a hex-ASCII string pointed
;	to by ES:DI.
;
hexw	proc	near		; Hex word
	push	ax		; Save word
	mov	al,ah		; High byte into low
	call	hexb		; Convert
	pop	ax		; Restore and fall through
hexb	proc	near		; Hex byte
	mov	ah,al		; Save byte
	shr	al, 4
	call	hexn		; Convert nibble
	mov	al,ah		; Restore byte, fall through
hexn	proc	near		; Hex nibble
	mov	bx,offset ascii	; Point to table
	and	al,0fh		; Mask 4 bits
	xlat			; Substitute
	stosb			; Save
	ret
hexn	endp
hexb	endp
hexw	endp
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
pseg	ends
end	start
